##********************************************************************************************************************
##TOOL NAME: Composite_Band
##SOURCE NAME: Composite_Band.py
##VERSION: 1
##AUTHOR: B.M.J. Possel (b.m.j.possel@student.tudelft.nl
##REQUIRED ARGUMENTS: Input folders (3), Output folder
##
##TOOL DESCRIPTION: Combines different Raster maps in different folders
##                  and writes the composite band to a selected Folder.
##
##DATE: February 9, 2009
##
##Usage: Composite_Band <Input_Folder> <Input_Folder> <Input_Folder> <Output_Folder>
##*********************************************************************************************************************

import sys, string, os, time
try:
    import win32com.client, pythoncom
except ImportError:
    print "Install PyWin32: http://www.python.org/download/windows/"
try:
    from numpy import *
    from numpy.linalg import inv
except ImportError:
    print "Install Numpy: www.numpy.org"
try:
    from osgeo import gdal
except ImportError:
    print "Install gdal: www.gdal.org"

msgSuccess="Successfully built file "
msgFail="Failed to build file "

gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
gp.SetProduct("ArcView")

# Check out any necessary licenses
gp.CheckOutExtension("spatial")

# Load required toolboxes...
gp.AddToolbox("C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Spatial Analyst Tools.tbx")

# Get inputs
##Dir1 = gp.GetParameterAsText(0)
##Dir2 = gp.GetParameterAsText(1)
##Dir3 = gp.GetParameterAsText(2)
##OutputFolder = gp.GetParameterAsText(3)
##
##filelist = os.listdir(Dir1)
##print filelist
##time.sleep(5)
##
##filelistsize = size(filelist)

#Get parameters
rasterlist = gp.GetParameterAsText(0)

Folder1 = gp.GetParameterAsText(1)
Folder1 = string.replace(Folder1, "\\", "/")

Folder2 = gp.GetParameterAsText(2)
Folder2 = string.replace(Folder2, "\\", "/")

Folder3 = gp.GetParameterAsText(3)
Folder3 = string.replace(Folder3, "\\", "/")

OutFolder = gp.GetParameterAsText(4)
OutFolder = string.replace(OutFolder, "\\", "/")

#Remove the parathesis around each input featureclass
rasterlist = string.replace(rasterlist, "(", "")
rasterlist = string.replace(rasterlist, ")", "")

#split input raster datasets by semicolon ";"
in_raster_ds = string.split(rasterlist, ";")

for in_raster in in_raster_ds:
    raster = in_raster

    if raster.startswith("'") and raster.endswith("'"):
        raster = raster[1:-1]

    raster = string.replace(raster, "\\", "/")
    print raster

    #Determine folder and filename
    File1 = raster
###    RasterName = string.split(raster, "_tpi.tif")
    RasterName = string.split(raster, "_tpi.tif_smoothed.tif")
    RasterName2 = RasterName[0]
    print RasterName2
    time.sleep(5)

### File2 = Folder1 + "/" + os.path.basename(RasterName2) + "_tpi.tif_smoothed.tif"
    File2 = Folder1 + "/" + os.path.basename(RasterName2) + "_tpi.tif"
    File3 = Folder2 + "/" + "slope_" + os.path.basename(RasterName2)
    File4 = Folder3 + "/" + os.path.basename(RasterName2) + "_curv.tif"

    OutFileName = string.split(raster, "_filtered2")
    OutFileName2 = OutFileName[0]
    OutFile = OutFolder + "/" + os.path.basename(OutFileName2) + "_composite.tif"

    #Convert names
    File1 = File1.encode('utf8')
    File2 = File2.encode('utf8')
    File3 = File3.encode('utf8')
    File4 = File4.encode('utf8')
    OutFile = OutFile.encode('utf8')

##    print "File names:"
##    print File1
##    print File2
##    print File3
##    print File4
##    print OutFile
##    time.sleep(5)
    print OutFile

    gp.CompositeBands_management(File1 + ";" + File2 + ";" + File3 + ";" + File4, OutFile)

    # Process: Composite Band
    #try:
        #gp.CompositeBands_management("seattle1.tif;seattle2.img;seattle3.tif","seattle_composite.tif")
    #    gp.CompositeBands_management(File1 + ";" + File2 + ";" + File3 + "," + OutFile)
        #gp.FocalStatistics_sa(InFile, OutFile, InNeighborhood, "", InNoDataOption)
    #except:
        # If an error occurred while running a tool, then print the messages.
    #    print gp.GetMessages()

    gp.AddMessage(msgSuccess + "%s" % raster)

        
#############################################################
