##********************************************************************************************************************
##TOOL NAME: FitPlane
##SOURCE NAME: FitPlane.py
##VERSION: 1.1
##AUTHOR: B.M.J. Possel (b.m.j.possel@student.tudelft.nl
##REQUIRED ARGUMENTS: Input raster, Output folder
##
##TOOL DESCRIPTION: Manipulates a Raster map and writes them to a selected Folder.
##
##DATE: July 15, 2008
##
##Usage: FitPlane <Input_Raster_Dataset> <Output_Folder> 
##
##Code inspired by Matthew Perry's "slope.cpp" and Julien Fiore's "openness.py"
##*********************************************************************************************************************


import sys, string, os, time
try:
    import win32com.client, pythoncom
except ImportError:
    print "Install PyWin32: http://www.python.org/download/windows/"

msgSuccess="Successfully built file "
msgFail="Failed to build file "

#import arcgisscripting
#gp = arcgisscripting.create()
gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
gp.SetProduct("ArcView")

## Check out Spatial Analyst extension license
#gp.CheckOutExtension("Spatial")

#The input rasters
rasterlist = gp.GetParameterAsText(0)

#Remove the parathesis around each input featureclass
rasterlist = string.replace(rasterlist, "(", "")
rasterlist = string.replace(rasterlist, ")", "")

#split input raster datasets by semicolon ";"
in_raster_ds = string.split(rasterlist, ";")
    
for in_raster in in_raster_ds:
    raster = in_raster

    if raster.startswith("'") and raster.endswith("'"):
        raster = raster[1:-1]

    OutFolder = gp.GetParameterAsText(1)
    OutFolder = string.replace(OutFolder, "\\", "/")

    BaseName = os.path.basename(raster)
    SplitBaseName = string.split(BaseName, ".")
    OutFile = OutFolder + "/" + SplitBaseName[0] + "_resample.tif"
    
    #OutFile = OutFolder + "/" + os.path.basename(raster) + "_resample.tif"
    raster = string.replace(raster, "\\", "/")
    InFile = raster + "/" + "w001001.adf"
    
    Size = int(gp.GetParameterAsText(2))

    InFile = InFile.encode('utf8')
    OutFile = OutFile.encode('utf8')
    
    print "input variables"
    print raster
    print InFile
    print OutFile
    print Size

    time.sleep(5)

    try:
        ##This section is for variance filter!
        #gp.workspace = "c:/redlands_data"
        gp.Resample_management(raster,OutFile,Size,"CUBIC")
        
    except:
        ## If an error occurred while running a tool, then print the messages.
        print gp.GetMessages()

    gp.AddMessage(msgSuccess + "%s" % raster)

#############################################################
