##********************************************************************************************************************
##TOOL NAME: TPIprocess
##SOURCE NAME: TPIprocess.py
##VERSION: 1.0
##AUTHOR: B.M.J. Possel (b.m.j.possel@student.tudelft.nl
##REQUIRED ARGUMENTS: Input matrix, orad, irad, nullValue
##
##TOOL DESCRIPTION: Calculates TPI values from a matrix and returns the result.
##
##DATE: December 3, 2008
##
##Usage: tpi = TPIprocess(matrix, orad, irad, nullValue)
##*********************************************************************************************************************

import sys, string, os, time
try:
    import win32com.client, pythoncom
except ImportError:
    print "Install PyWin32: http://www.python.org/download/windows/"
try:
    from numpy import *
except ImportError:
    print "Install Numpy: www.numpy.org"
try:
    from osgeo import gdal
except ImportError:
    print "Install gdal: www.gdal.org"

__all__ = ["TPIprocess"]

def TPIprocess(matrix, orad, irad, nullValue, nullValue2):
    [s,t] = shape(matrix)
    sumring = zeros((s,t),dtype='float32')
    tpi = ones((s,t),dtype='float32')*nullValue2

    # Make Model
    model = zeros(((2*orad+1),(2*orad+1)),dtype='float32')
    
    [k,l] = shape(model)
    for a in range(k)[0:(2*orad+1)]:
        for b in range(l)[0:(2*orad+1)]:
            if  sqrt((orad-a)**2+(orad-b)**2) <= orad and sqrt((orad-a)**2+(orad-b)**2) >= irad:
               model[a,b] = 1
    SumModel = sum(model)
    #ringmodel = zeros(((2*orad+1),(2*orad+1)),float)

    for i in range(s)[(orad):(s-(orad+1))]:
        for j in range(t)[(orad):(t-(orad+1))]:
            if matrix[i,j] != nullValue:
                plain = matrix[(i-orad):(i+orad+1),(j-orad):(j+orad+1)]

#                TnoNaN = zeros((k,l),float)
#                TnoNaN = plain.take([where(plain!=nullValue)[0]]).take([where(plain!=nullValue)[1]], axis=1)
#                TnoNaN = plain.take([where(plain!=nullValue)[0]].take([where(plain!=nullValue)[1]], axis=1)
#                TnoNaN = plain[where(plain!=nullValue)[0],where(plain!=nullValue)[1]]
                
                ringmodel = model*plain #Select annulus

                #NaNs = zeros(((2*orad+1),(2*orad+1)),float)
                #NaNs = (ringmodel==nullValue).choose(NaNs,1) #Remove all NullValues
                #SumModelNoNaNs = SumModel - sum(NaNs)

                ringmodel2 = (ringmodel==nullValue).choose(ringmodel,0)
                [test1,test2] = where(ringmodel2!=0)
                if test1.size >= 30:
                    sumring[i,j] = sum(ringmodel2)/test1.size
                    tpi[i,j] = matrix[i,j] - sumring[i,j] #+ 0.5
    print tpi.max()
    print tpi.min()
    time.sleep(10)

    ###########End Padding script###########

    return tpi
