import sys, string, os
try:
    import win32com.client, pythoncom
except ImportError:
    print "Install PyWin32: http://www.python.org/download/windows/"
try:
    from numpy import *
except ImportError:
    print "Install Numpy: www.numpy.org"
try:
    from osgeo import gdal
except ImportError:
    print "Install gdal: www.gdal.org"

#baseraster = 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/av07_38d026g0/w001001.adf'
#u = 20      #windowsize
#u = (w-1)/2

__all__ = ["padding"]

def padding(baseraster,u):
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
    gp.SetProduct("ArcView")

    ###########Begin Padding script###########

    #Import topology files
    Directory = os.path.dirname(baseraster)
    print Directory

    try:
        raster = open ( Directory + '/Topology/0Raster.txt' )
        above = open ( Directory + '/Topology/1Above.txt' )
        right = open ( Directory + '/Topology/2Right.txt' )
        below = open ( Directory + '/Topology/3Below.txt' )
        left = open ( Directory + '/Topology/4Left.txt' )
    except:
        ## If an error occurred while running a tool, then print the messages.
        print 'There is no Topology file...'
      
##    raster = open ( 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/Topology/0Raster.txt' )
##    above = open ( 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/Topology/1Above.txt' )
##    right = open ( 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/Topology/2Right.txt' )
##    below = open ( 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/Topology/3Below.txt' )
##    left = open ( 'E:/Afstuderen_BMJ_Possel/Data/3._1x1.25km_g0/Topology/4Left.txt' )
    
    raster2 = raster.read()
    above2 = above.read()
    right2 = right.read()
    below2 = below.read()
    left2 = left.read()
    raster.close()
    above.close()
    right.close()
    below.close()
    left.close()
    raster = eval(raster2)
    above = eval(above2)
    right = eval(right2)
    below = eval(below2)
    left = eval(left2)

    #Find input raster in topology file
    for i,v in enumerate(raster):
        if v == baseraster:
            number = i                                      #Row number of input raster

    #Load data
    print (raster[number])
    
    inGrid = gdal.Open(raster[number])
    inGridBand = inGrid.GetRasterBand(1)
    basemodel = inGridBand.ReadAsArray()
    nullValue = basemodel.min()
    #nullValue = inGridBand.GetNoDataValue()         #For some reason it doesn't always work...
    [s,t] = shape(basemodel)

    print nullValue
    print s
    print t

    model = ones(((s+2*u),(t+2*u)),float)*nullValue    #Make new over-sized matrix

    print shape(basemodel)
    print shape(model)

    #Import neighbours and apply padding
    if bool(left[number]) == True:
        inGrid_L = gdal.Open(left[number])
        inGridBand_L = inGrid_L.GetRasterBand(1)
        matrix_L = inGridBand_L.ReadAsArray()
        [s2,t2] = shape(matrix_L)
        try:
            model[u:(s2+u),0:u]=matrix_L[0:s2,(t2-u-1):(t2-1)]         #Add data left
        except:
            ## If an error occurred while running a tool, then print the messages.
            print 'The tile to the left is the problem...'

    if bool(below[number]) == True:
        inGrid_B = gdal.Open(below[number])
        inGridBand_B = inGrid_B.GetRasterBand(1)
        matrix_B = inGridBand_B.ReadAsArray()
        [s3,t3] = shape(matrix_B)
        try:
            model[-u:,(u):(t3+u)]=matrix_B[1:(u+1),0:t3]   #Add data right
        except:
            ## If an error occurred while running a tool, then print the messages.
            print 'The tile to the right is the problem...'

    #Add data central tile -> leave in this sequence due to No-Value lines at the side!
    model[u:(s+u),u:(t+u)] = basemodel

    if bool(right[number]) == True:
        inGrid_R = gdal.Open(right[number])
        inGridBand_R = inGrid_R.GetRasterBand(1)
        matrix_R = inGridBand_R.ReadAsArray()
        [s4,t4] = shape(matrix_R)
        print u
        print s4
        print (s4+u)
        print (u+1)
        test = model[u:(s4+u),-(u+1):-1]
        test2 = matrix_R[0:s4,0:u]
        print shape(test)
        print shape(test2)
        try:
            model[u:(s4+u),-(u+1):-1]=matrix_R[0:s4,0:u]   #Add data below
        except:
            ## If an error occurred while running a tool, then print the messages.
            print 'The tile below is the problem...'

    if bool(above[number]) == True:    
        inGrid_A = gdal.Open(above[number])
        inGridBand_A = inGrid_A.GetRasterBand(1)
        matrix_A = inGridBand_A.ReadAsArray()
        [s5,t5] = shape(matrix_A)
        try:
            model[1:(u+1),u:(t5+u)]=matrix_A[(s5-u):s2,0:t5]         #Add data left
        except:
            ## If an error occurred while running a tool, then print the messages.
            print 'The tile above is the problem...'

    ###########End Padding script###########

    print 'above: '
    print above[number]
    print 'right: '
    print right[number]
    print 'below: '
    print below[number]
    print 'left: '
    print left[number]

    return model, basemodel
